# Guides Overview

This part of the Boden Framework documentation contains guides that are intended to help you learn Boden to make it easier and more fun to write your cross-platform apps.

!!! warning
	The Boden API is work in progress and may change in the coming months. [Follow us on Twitter](https://twitter.com/bodenhq) and [star/watch our repo on GitHub](https://github.com/AshampooSystems/boden) to stay in the loop!

## Getting Started

If you did not yet set up and build Boden, please refer to the [Getting Started](../getting-started) section featuring a quick start and detailed guides on how to get your system set up for building Boden.

## Boden Fundamentals

Explains the [Boden Property System](fundamentals/properties.md). This part of the Guides section will be extended in the future to explain the basic Boden architecture, design considerations, and how to get started with fundamental Boden features to implement your apps.

## Extending Boden

The Extending Boden section is intended to help you create [your own Boden view components](extending/writing_view.md). It's also a good place to start if you are interested in the inner workings of Boden and how it implements wrapper classes around platform-specific features.